package blusunrize.immersiveengineering.common.crafting;

import blusunrize.immersiveengineering.api.Lib;
import blusunrize.immersiveengineering.common.IEContent;
import blusunrize.immersiveengineering.common.items.IEItemInterfaces.IColouredItem;
import blusunrize.immersiveengineering.common.util.ItemNBTHelper;
import blusunrize.immersiveengineering.common.util.Utils;
import com.google.common.collect.Lists;
import net.minecraft.entity.passive.EntitySheep;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.inventory.InventoryCrafting;
import net.minecraft.item.EnumDyeColor;
import net.minecraft.item.ItemArmor;
import net.minecraft.item.ItemStack;
import net.minecraft.item.crafting.IRecipe;
import net.minecraft.util.NonNullList;
import net.minecraft.world.World;
import net.minecraftforge.common.ForgeHooks;

import java.util.List;

public class RecipeEarmuffs extends net.minecraftforge.registries.IForgeRegistryEntry.Impl<IRecipe> implements IRecipe
{
	@Override
	public boolean func_77569_a(InventoryCrafting inv, World world)
	{
		ItemStack earmuffs = ItemStack.field_190927_a;
		ItemStack armor = ItemStack.field_190927_a;
		List<ItemStack> list = Lists.newArrayList();
		for(int i=0;i<inv.func_70302_i_();i++)
		{
			ItemStack stackInSlot = inv.func_70301_a(i);
			if(!stackInSlot.func_190926_b())
				if(earmuffs.func_190926_b() && IEContent.itemEarmuffs.equals(stackInSlot.func_77973_b()))
					earmuffs = stackInSlot;
				else if(armor.func_190926_b() && stackInSlot.func_77973_b() instanceof ItemArmor && ((ItemArmor) stackInSlot.func_77973_b()).field_77881_a == EntityEquipmentSlot.HEAD && !IEContent.itemEarmuffs.equals(stackInSlot.func_77973_b()))
					armor = stackInSlot;
				else if(Utils.isDye(stackInSlot))
					list.add(stackInSlot);
				else
					return false;
		}
		if(!earmuffs.func_190926_b() && (!armor.func_190926_b() ||!list.isEmpty()))
			return true;
		else if(!armor.func_190926_b() && ItemNBTHelper.hasKey(armor, Lib.NBT_Earmuffs) && earmuffs.func_190926_b() && list.isEmpty())
			return true;
		return false;
	}

	@Override
	public ItemStack func_77572_b(InventoryCrafting inv)
	{
		ItemStack earmuffs = ItemStack.field_190927_a;
		ItemStack armor = ItemStack.field_190927_a;
		int[] colourArray = new int[3];
		int j = 0;
		int totalColourSets = 0;
		for(int i=0;i<inv.func_70302_i_();i++)
		{
			ItemStack stackInSlot = inv.func_70301_a(i);
			if(!stackInSlot.func_190926_b())
				if(earmuffs.func_190926_b() && IEContent.itemEarmuffs.equals(stackInSlot.func_77973_b()))
				{
					earmuffs = stackInSlot;
					int colour = ((IColouredItem)earmuffs.func_77973_b()).getColourForIEItem(earmuffs, 0);
					float r = (float)(colour >> 16 & 255) / 255.0F;
					float g = (float)(colour >> 8 & 255) / 255.0F;
					float b = (float)(colour & 255) / 255.0F;
					j = (int)((float)j + Math.max(r, Math.max(g, b)) * 255.0F);
					colourArray[0] = (int)((float)colourArray[0] + r * 255.0F);
					colourArray[1] = (int)((float)colourArray[1] + g * 255.0F);
					colourArray[2] = (int)((float)colourArray[2] + b * 255.0F);
					++totalColourSets;
				}
				else if(Utils.isDye(stackInSlot))
				{
					float[] afloat = EntitySheep.func_175513_a(EnumDyeColor.func_176766_a(Utils.getDye(stackInSlot)));
					int r = (int)(afloat[0] * 255.0F);
					int g = (int)(afloat[1] * 255.0F);
					int b = (int)(afloat[2] * 255.0F);
					j += Math.max(r, Math.max(g, b));
					colourArray[0] += r;
					colourArray[1] += g;
					colourArray[2] += b;
					++totalColourSets;
				}
				else if(armor.func_190926_b() && stackInSlot.func_77973_b() instanceof ItemArmor && ((ItemArmor)stackInSlot.func_77973_b()).field_77881_a==EntityEquipmentSlot.HEAD && !IEContent.itemEarmuffs.equals(stackInSlot.func_77973_b()))
					armor = stackInSlot;
		}

		if(!earmuffs.func_190926_b())
		{
			if(totalColourSets>1)
			{
				int r = colourArray[0] / totalColourSets;
				int g = colourArray[1] / totalColourSets;
				int b = colourArray[2] / totalColourSets;
				float colourMod = (float)j / (float)totalColourSets;
				float highestColour = (float)Math.max(r, Math.max(g, b));
				r = (int)((float)r * colourMod / highestColour);
				g = (int)((float)g * colourMod / highestColour);
				b = (int)((float)b * colourMod / highestColour);
				int newColour = (r << 8) + g;
				newColour = (newColour << 8) + b;
				ItemNBTHelper.setInt(earmuffs, Lib.NBT_EarmuffColour, newColour);
			}
			ItemStack output;
			if(!armor.func_190926_b())
			{
				output = armor.func_77946_l();
				ItemNBTHelper.setItemStack(output, Lib.NBT_Earmuffs, earmuffs.func_77946_l());
			}
			else
				output = earmuffs.func_77946_l();
			return output;
		}
		else if(!armor.func_190926_b() && ItemNBTHelper.hasKey(armor, Lib.NBT_Earmuffs))
		{
			ItemStack output = armor.func_77946_l();
			ItemNBTHelper.remove(output, Lib.NBT_Earmuffs);
			return output;
		}
		return ItemStack.field_190927_a;
	}

	@Override
	public boolean func_194133_a(int width, int height)
	{
		return width>=2 && height>=2;
	}

	@Override
	public ItemStack func_77571_b()
	{
		return new ItemStack(IEContent.itemBullet,1,10);
	}

	@Override
	public NonNullList<ItemStack> func_179532_b(InventoryCrafting inv)
	{
		NonNullList<ItemStack> remaining = ForgeHooks.defaultRecipeGetRemainingItems(inv);
		for(int i=0;i<remaining.size();i++)
		{
			ItemStack stackInSlot = inv.func_70301_a(i);
			if(!stackInSlot.func_190926_b() && ItemNBTHelper.hasKey(stackInSlot, Lib.NBT_Earmuffs))
				remaining.set(i, ItemNBTHelper.getItemStack(stackInSlot, Lib.NBT_Earmuffs));
		}
		return remaining;
	}
}
